<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page import="java.util.*"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.view.MobileGatewayUser"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.MobileGatewaySession"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceResponse"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceResponseCode"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceRequest"%>
<%@ page import="com.invoqsystems.apex.exceptions.AlarmPointDatabaseException"%>
<%@ page import="com.invoqsystems.apex.exceptions.AlarmPointNetworkException"%>
<%@ page import="com.invoqsystems.apex.web.exceptions.AlarmPointTimeOutException"%>
<%@ page import="com.invoqsystems.integration.remedy.scriptobjects.*"%>

<jsp:useBean class="com.alarmpoint.apex.mobilegateway.util.MobileGatewaySession" id="mobileGatewaySession" scope="session" />

<%
//Get the updated incident from the session
IncidentScriptObject updatedIncident = (IncidentScriptObject)session.getAttribute("incident");
String incidentNumber = (String)updatedIncident.get( "Incident_Number" );

if ( request.getParameter("cancelUpdate") != null )
{
  String status = "&message=Update Canceled";
  %>
  <jsp:forward page="<%=response.encodeURL("loadIncident.jsp?IncidentNumber="+incidentNumber+status)%>"/>
  <%
}

//Retrieve the possibly updated incident from Service Desk
ExternalServiceRequest esr = mobileGatewaySession.createExternalServiceRequest();
ExternalServiceResponse resps;
esr.setAction("getIncidentDetail");
esr.addToken("IncidentNumber", incidentNumber);
%>
<%@ include file="includes/sendRequest.jsp"%>
<%
if( resps.getResponse() instanceof String )
{
  String status = "&errorMessage="+resps.getResponse();
  %>
  <jsp:forward page="<%=response.encodeURL("updateIncident.jsp?"+status)%>"/>
  <%
}
IncidentScriptObject oldIncident = (IncidentScriptObject)resps.getResponse();
boolean hasConflict = false;
if( request.getParameter("forceUpdate") == null )
{
  %>
  <%@ include file="includes/diff.jsp"%>
  <%
}
if( !hasConflict )
{
  // Main Update with APSDI_HPD_IncidentInterface_WS
  String webService = "APSDI_HPD_IncidentInterface_WS";
  String operation = "HelpDesk_Modify_Service_MG";
  Map<String, Object> complexMap = new LinkedHashMap<String, Object>();
  complexMap.put( "Incident", updatedIncident.getFields() );

  String updatedStatus = (String)updatedIncident.get( "Status" );
  boolean statusUpdated = updatedIncident.getUpdateMap().containsKey( "Status" ) &&
    ("Pending".equals(updatedStatus) || "Resolved".equals(updatedStatus) );
  statusUpdated = statusUpdated || updatedIncident.getUpdateMap().containsKey( "Status_Reason" );

  if ( statusUpdated )
  {
    updatedIncident.getUpdateMap().remove( "Status" );
  }

  esr = mobileGatewaySession.createExternalServiceRequest();
  esr.setAction( "sendComplexRequest" );
  esr.addToken("complexMap", complexMap );
  esr.addToken("operation", operation);
  esr.addToken("webService", webService);
  esr.addToken("requestNS", webService);
  esr.addToken("responseNS", webService);
  %>
  <%@ include file="includes/sendRequest.jsp"%>
  <%
  String status = (String)resps.getResponse();

  // Update Status separately because the WS provided by Remedy does not update Status Reason
  if ( statusUpdated )
  {
    // Update Status
      webService = "APSDI_HPD_HelpDesk_WS";
      operation = "MG_Set_Status";
      esr = mobileGatewaySession.createExternalServiceRequest();
      esr.setAction( "sendGenericRequest" );
      Map<String, String> statusFields = new LinkedHashMap<String, String>();
      statusFields.put("Status", updatedStatus );
      statusFields.put("z1D_Action", "MODIFY" );
      statusFields.put("Incident_Number", (String)updatedIncident.get("Incident_Number") );
      statusFields.put("Status_Reason", (String)updatedIncident.get("Status_Reason") );
      esr.addToken("fields", statusFields);
      esr.addToken("operation", operation);
      esr.addToken("webService", webService);
      esr.addToken("requestNS", webService);
      esr.addToken("responseNS", webService);
      %>
      <%@ include file="includes/sendRequest.jsp"%>
      <%
      status = (String)resps.getResponse();
  }

  // Only update Assignment, if it was changed
  String updatedAssignID = (String)updatedIncident.getUpdateMap().get("Assignment:::Assigned_Group_ID");
  if ( status == null && updatedAssignID != null && updatedAssignID.length() > 0 )
  {
    // Update Assign
    esr = mobileGatewaySession.createExternalServiceRequest();
    esr.setAction( "assignIncident" );
    Map<String, String> assignFields = new LinkedHashMap<String, String>();
    assignFields.put("z1D_Action", "MODIFY" );
    assignFields.put("Incident_Number", (String)updatedIncident.get("Incident_Number") );
    assignFields.put("Assigned_Group", (String)updatedIncident.get("Assignment:::Assigned_Group") );
    assignFields.put("Assigned_Group_ID", (String)updatedIncident.get("Assignment:::Assigned_Group_ID") );
    assignFields.put("Assigned_Support_Company", (String)updatedIncident.get("Assignment:::Support_Company") );
    assignFields.put("Assigned_Support_Organization", (String)updatedIncident.get("Assignment:::Assigned_Support_Organization") );
    assignFields.put("Assignee", (String)updatedIncident.get("Assignment:::Assignee") );
    //Investigation with BMC discovered that the Assignee_Id field does not need to be set.
    //assignFields.put("Assignee_Id", (String)updatedIncident.get("Assignment:::Person_ID") );
    assignFields.put("Assignee_Login_ID", (String)updatedIncident.get("Assignment:::Login_ID") );
    esr.addToken("assignFields", assignFields);
    %>
    <%@ include file="includes/sendRequest.jsp"%>
    <%
    status = (String)resps.getResponse();
  }

  // Only update Owner, if it was changed
  String updatedOwnerID = (String)updatedIncident.getUpdateMap().get("Assignment:::Owner_Group_ID");
  if ( status == null && updatedOwnerID != null && updatedOwnerID.length() > 0 )
  {
    // Update Owner
    esr = mobileGatewaySession.createExternalServiceRequest();
    esr.setAction( "ownIncident" );
    Map<String, String> ownFields = new LinkedHashMap<String, String>();
    ownFields.put("Owner_Support_Company", (String)updatedIncident.get("Assignment:::Owner_Support_Company") );
    ownFields.put("Owner_Support_Organization", (String)updatedIncident.get("Assignment:::Owner_Support_Organization") );
    ownFields.put("z1D_Action", "MODIFY" );
    ownFields.put("Incident_Number", (String)updatedIncident.get("Incident_Number") );
    ownFields.put("Owner_Group_ID", (String)updatedIncident.get("Assignment:::Owner_Group_ID") );
    ownFields.put("Owner_Login_ID", (String)updatedIncident.get("Assignment:::Owner_Login_ID") );
    ownFields.put("Owner", (String)updatedIncident.get("Assignment:::Owner") );
    ownFields.put("Owner_Group", (String)updatedIncident.get("Assignment:::Owner_Group") );
    esr.addToken("ownFields", ownFields);
    %>
    <%@ include file="includes/sendRequest.jsp"%>
    <%
    status = (String)resps.getResponse();
  }

  if ( status == null )
  {
    // Update Customer
    webService = "APSDI_HPD_HelpDesk_WS";
    operation = "HelpDesk_Set_Customer";
    esr = mobileGatewaySession.createExternalServiceRequest();
    esr.setAction( "sendGenericRequest" );
    Map<String, String> custFields = new LinkedHashMap<String, String>();
    custFields.put("Company", (String)updatedIncident.get("Customer:::Company") );
    custFields.put("Department", (String)updatedIncident.get("Customer:::Department") );
    custFields.put("First_Name", (String)updatedIncident.get("Customer:::First_Name") );
    custFields.put("Last_Name", (String)updatedIncident.get("Customer:::Last_Name") );
    custFields.put("Middle_Initial", (String)updatedIncident.get("Customer:::Middle_Name") );
    custFields.put("Organization", (String)updatedIncident.get("Customer:::Organization") );
    custFields.put("Phone_Number", (String)updatedIncident.get("Customer:::Phone_Number") );
    custFields.put("Site", (String)updatedIncident.get("Customer:::Site") );
    custFields.put("z1D_Action", "MODIFY" );
    custFields.put("Incident_Number", (String)updatedIncident.get("Incident_Number") );
    custFields.put("Site_Group", (String)updatedIncident.get("Customer:::Site_Group") );
    custFields.put("Site_ID", (String)updatedIncident.get("Customer:::Site_ID") );
    custFields.put("Region", (String)updatedIncident.get("Customer:::Region") );
    esr.addToken("fields", custFields);
    esr.addToken("operation", operation);
    esr.addToken("webService", webService);
    esr.addToken("requestNS", webService);
    esr.addToken("responseNS", webService);
    %>
    <%@ include file="includes/sendRequest.jsp"%>
    <%
    status = (String)resps.getResponse();
  }

  if ( status == null )
  {
    // Update Contact
    webService = "APSDI_HPD_HelpDesk_WS";
    operation = "HelpDesk_Set_Contact";
    esr = mobileGatewaySession.createExternalServiceRequest();
    esr.setAction( "sendGenericRequest" );
    Map<String, String> contactFields = new LinkedHashMap<String, String>();
    contactFields.put("Direct_Contact_Company", (String)updatedIncident.get("Contact:::Company") );
    contactFields.put("Direct_Contact_Department", (String)updatedIncident.get("Contact:::Department") );
    contactFields.put("Direct_Contact_First_Name", (String)updatedIncident.get("Contact:::First_Name") );
    contactFields.put("Direct_Contact_Internet_E-mail", (String)updatedIncident.get("Contact:::Internet_E-Mail") );
    contactFields.put("Direct_Contact_Last_Name", (String)updatedIncident.get("Contact:::Last_Name") );
    contactFields.put("Direct_Contact_Middle_Initial", (String)updatedIncident.get("Contact:::Middle_Name") );
    contactFields.put("Direct_Contact_Organization", (String)updatedIncident.get("Contact:::Organization") );
    contactFields.put("Direct_Contact_Phone_Number", (String)updatedIncident.get("Contact:::Phone_Number") );
    contactFields.put("Direct_Contact_Site", (String)updatedIncident.get("Contact:::Site") );
    contactFields.put("Incident_Number", (String)updatedIncident.get("Incident_Number") );
    esr.addToken("fields", contactFields);
    esr.addToken("operation", operation);
    esr.addToken("webService", webService);
    esr.addToken("requestNS", webService);
    esr.addToken("responseNS", webService);
    %>
    <%@ include file="includes/sendRequest.jsp"%>
    <%
    status = (String)resps.getResponse();
  }

  if ( status == null )
  {
    esr = mobileGatewaySession.createExternalServiceRequest();
    Map<String, String> vendorFields = new LinkedHashMap<String, String>();

    // Update Full Vendor details if Group ID is present
    String vendorGroupID = (String)updatedIncident.get("Vendor:::Vendor_Group_ID");
    if ( vendorGroupID != null && vendorGroupID.length() > 0)
    {
      webService = "APSDI_HPD_HelpDesk_WS";
      operation = "MG_HelpDesk_Set_Vendor";
      esr.setAction( "sendGenericRequest" );
      vendorFields.put("z1D_Action", "MODIFY" );
      vendorFields.put("Incident_Number", (String)updatedIncident.get("Incident_Number") );
      vendorFields.put("Reported_to_Vendor", (String)updatedIncident.get("Vendor:::Reported_to_Vendor_Date") );
      vendorFields.put("Vendor_Assignment_Status", (String)updatedIncident.get("Vendor:::Vendor_Assignment_Status") );
      vendorFields.put("Vendor_Email", (String)updatedIncident.get("Vendor:::Vendor_Email") );
      vendorFields.put("Vendor_First_Name", (String)updatedIncident.get("Vendor:::Vendor_First_Name") );
      vendorFields.put("Vendor_Group", (String)updatedIncident.get("Vendor:::Vendor_Group") );
      vendorFields.put("Vendor_Group_ID", (String)updatedIncident.get("Vendor:::Vendor_Group_ID") );
      vendorFields.put("Vendor_Last_Name", (String)updatedIncident.get("Vendor:::Vendor_Last_Name") );
      vendorFields.put("Vendor_Login_ID", null );
      vendorFields.put("Vendor_Name", (String)updatedIncident.get("Vendor:::Vendor_Company") );
      vendorFields.put("Vendor_Organization", (String)updatedIncident.get("Vendor:::Vendor_Organization") );
      vendorFields.put("Vendor_Person_ID", null );
      vendorFields.put("Vendor_Phone", (String)updatedIncident.get("Vendor:::Vendor_Phone") );
      vendorFields.put("Vendor_Resolved_Date", (String)updatedIncident.get("Vendor:::Vendor_Resolved_Date") );
      vendorFields.put("Vendor_Responded_On", (String)updatedIncident.get("Vendor:::Vendor_Responded_Date") );
      vendorFields.put("Vendor_Ticket_Number", (String)updatedIncident.get("Vendor:::Vendor_Ticket_Number") );
    }
    // Otherwise just update the ticket and contact information
    else
    {
      webService = "APSDI_HPD_HelpDesk_WS";
      operation = "MG_HPD_Set_Vendor_Ticket";
      esr.setAction( "sendGenericRequest" );
      vendorFields.put("z1D_Action", "MODIFY" );
      vendorFields.put("Incident_Number", (String)updatedIncident.get("Incident_Number") );
      vendorFields.put("Reported_to_Vendor", (String)updatedIncident.get("Vendor:::Reported_to_Vendor_Date") );
      vendorFields.put("Vendor_Assignment_Status", (String)updatedIncident.get("Vendor:::Vendor_Assignment_Status") );
      vendorFields.put("Vendor_Email", (String)updatedIncident.get("Vendor:::Vendor_Email") );
      vendorFields.put("Vendor_First_Name", (String)updatedIncident.get("Vendor:::Vendor_First_Name") );
      vendorFields.put("Vendor_Last_Name", (String)updatedIncident.get("Vendor:::Vendor_Last_Name") );
      vendorFields.put("Vendor_Phone", (String)updatedIncident.get("Vendor:::Vendor_Phone") );
      vendorFields.put("Vendor_Resolved_Date", (String)updatedIncident.get("Vendor:::Vendor_Resolved_Date") );
      vendorFields.put("Vendor_Responded_On", (String)updatedIncident.get("Vendor:::Vendor_Responded_Date") );
      vendorFields.put("Vendor_Ticket_Number", (String)updatedIncident.get("Vendor:::Vendor_Ticket_Number") );
    }
    esr.addToken("fields", vendorFields);
    esr.addToken("operation", operation);
    esr.addToken("webService", webService);
    esr.addToken("requestNS", webService);
    esr.addToken("responseNS", webService);
    %>
    <%@ include file="includes/sendRequest.jsp"%>
    <%
    status = (String)resps.getResponse();
  }

  if ( status == null )
  {
    // Update Resolution
    webService = "APSDI_HPD_HelpDesk_WS";
    operation = "HelpDesk_Set_Resolution";
    esr = mobileGatewaySession.createExternalServiceRequest();
    esr.setAction( "sendGenericRequest" );
    Map<String, String> resolutionFields = new LinkedHashMap<String, String>();
    resolutionFields.put("z1D_Action", "MODIFY" );
    resolutionFields.put("Closure_Manufacturer", (String)updatedIncident.get("Resolution:::Resolution_Product_Categorization:::Manufacturer") );
    resolutionFields.put("Closure_Product_Category_Tier1", (String)updatedIncident.get("Resolution:::Resolution_Product_Categorization:::Tier_1") );
    resolutionFields.put("Closure_Product_Category_Tier2", (String)updatedIncident.get("Resolution:::Resolution_Product_Categorization:::Tier_2") );
    resolutionFields.put("Closure_Product_Category_Tier3", (String)updatedIncident.get("Resolution:::Resolution_Product_Categorization:::Tier_3") );
    resolutionFields.put("Closure_Product_Model_Version", (String)updatedIncident.get("Resolution:::Resolution_Product_Categorization:::Model-Version") );
    resolutionFields.put("Closure_Product_Name", (String)updatedIncident.get("Resolution:::Resolution_Product_Categorization:::Product_Name") );
    resolutionFields.put("Closure_Source", (String)updatedIncident.get("Resolution:::Closure_Source") );
    resolutionFields.put("Estimated_Resolution_Date", (String)updatedIncident.get("Resolution:::Estimated_Resolution_Date") );
    resolutionFields.put("Generic_Categorization_Tier_1", (String)updatedIncident.get("Resolution:::Cause") );
    resolutionFields.put("Incident_Number", (String)updatedIncident.get("Incident_Number") );
    resolutionFields.put("Required_Resolution_DateTime", (String)updatedIncident.get("Resolution:::Required_Resolution_Date") );
    resolutionFields.put("Resolution", (String)updatedIncident.get("Resolution:::Resolution") );
    resolutionFields.put("Resolution_Category", (String)updatedIncident.get("Resolution:::Resolution_Categorization:::Tier_1") );
    resolutionFields.put("Resolution_Category_Tier_2", (String)updatedIncident.get("Resolution:::Resolution_Categorization:::Tier_2") );
    resolutionFields.put("Resolution_Category_Tier_3", (String)updatedIncident.get("Resolution:::Resolution_Categorization:::Tier_3") );
    resolutionFields.put("Resolution_Method", (String)updatedIncident.get("Resolution:::Resolution_Method") );
    resolutionFields.put("Satisfaction_Rating", (String)updatedIncident.get("Resolution:::Satisfaction_Rating") );
    esr.addToken("fields", resolutionFields);
    esr.addToken("operation", operation);
    esr.addToken("webService", webService);
    esr.addToken("requestNS", webService);
    esr.addToken("responseNS", webService);
    %>
    <%@ include file="includes/sendRequest.jsp"%>
    <%
    status = (String)resps.getResponse();
  }

  if ( status == null )
  {
    status = "&message=OK";

    %>
    <jsp:forward page="<%=response.encodeURL("loadIncident.jsp?IncidentNumber="+incidentNumber+status)%>"/>
    <%
  }
  else
  {
    String tab = "";
    if(status.startsWith("Please provide an update"))
      tab = "&tab=add_action";
    status = "&errorMessage="+status;
    %>
    <jsp:forward page="<%=response.encodeURL("updateIncident.jsp?"+status+tab)%>"/>
    <%
  }
}
%>