<%
  fields.put( "Summary", "Summary" );
  fieldTypes.put("Summary", "Text");
  requiredFields.add("Summary");

  fields.put("Status", "Status");
  fieldTypes.put("Status", "Status");
  requiredFields.add("Status");

  fields.put("Impact", "Impact");
  fieldTypes.put("Impact", "Impact");
  requiredFields.add("Impact");

  fields.put("Urgency", "Urgency");
  fieldTypes.put("Urgency", "Urgency");
  requiredFields.add("Urgency");

  fields.put("Customer", "Customer");
  fieldTypes.put("Customer", "Customer");
  requiredFields.add("Customer");

  fields.put("Assigned_Group", "Assign Grp");
  fieldTypes.put("Assigned_Group", "Group");
  requiredFields.add("Assigned_Group");

  fields.put("Assignee", "Assignee");
  fieldTypes.put("Assignee", "Assignee");

  fields.put("Service_Type", "Svc Type");
  fieldTypes.put("Service_Type", "Service_Type");

  fields.put("Operational_Category", "Oper Cat");
  fieldTypes.put("Operational_Category", "Table");

  fields.put("Operational_Category:::Tier_1", "Tier 1");
  fieldTypes.put("Operational_Category:::Tier_1", "OpCat");

  fields.put("Operational_Category:::Tier_2", "Tier 2");
  fieldTypes.put("Operational_Category:::Tier_2", "Disabled");

  fields.put("Operational_Category:::Tier_3", "Tier 3");
  fieldTypes.put("Operational_Category:::Tier_3", "Disabled");

  fields.put("Operational_Category_End", "Oper Cat");
  fieldTypes.put("Operational_Category_End", "TableEnd");

  fields.put("Product_Category", "Prod Cat");
  fieldTypes.put("Product_Category", "Table");

  fields.put("Product_Category:::Tier_1", "Tier 1");
  fieldTypes.put("Product_Category:::Tier_1", "ProdCat");

  fields.put("Product_Category:::Tier_2", "Tier 2");
  fieldTypes.put("Product_Category:::Tier_2", "Disabled");

  fields.put("Product_Category:::Tier_3", "Tier 3");
  fieldTypes.put("Product_Category:::Tier_3", "Disabled");

  fields.put("Product_Name", "Product");
  fieldTypes.put("Product_Name", "Disabled");

  fields.put("Model-Version", "Model");
  fieldTypes.put("Model-Version", "Text");

  fields.put("Manufacturer", "Mfgr");
  fieldTypes.put("Manufacturer", "Disabled");

  fields.put("Product_Category_End", "Prod Cat");
  fieldTypes.put("Product_Category_End", "TableEnd");

  fields.put("Department", "Dept");
  fieldTypes.put("Department", "Hidden");

  fields.put("First_Name", "F Name");
  fieldTypes.put("First_Name", "Hidden");

  fields.put("Last_Name", "L Name");
  fieldTypes.put("Last_Name", "Hidden");

  fields.put("Assigned_Support_Company", "Assign Com");
  fieldTypes.put("Assigned_Support_Company", "Hidden");

  fields.put("Assigned_Support_Organization", "Assign Org");
  fieldTypes.put("Assigned_Support_Organization", "Hidden");

  //Add Web Service Field to JSP Field name mapping to Incident
  %>
  <%@ include file="createWSFields.jsp"%>
  <%

  // Build the orginal map
  List<String> excludes =
      Arrays.asList( new String[] {
              "Product_Category",
              "Product_Category_End",
              "Operational_Category",
              "Operational_Category_End"
  });

  ic.buildOriginalMap( fields.keySet(), excludes );
  ic.addUpdate( "Action", "CREATE" );
  ic.addUpdate( "Create_Request", "No" );

  // Used for auto fill
  //
  Map<String,List<String>> autoFills = new HashMap<String,List<String>>();
  session.setAttribute( "autoFillFields", autoFills );
  Map<String,List<String>> autoFillClears = new HashMap<String,List<String>>();
  session.setAttribute( "autoFillClears", autoFillClears );

  // Operational Category
  List<String> opCat = new ArrayList<String>();
  autoFills.put( "OpCat", opCat );
  // Entry matches jsp field name
  opCat.add( "Operational_Category:::Tier_1" );
  opCat.add( "Operational_Category:::Tier_2" );
  opCat.add( "Operational_Category:::Tier_3" );

  // Product Category
  List<String> prodCat = new ArrayList<String>();
  autoFills.put( "ProdCat", prodCat );
  prodCat.add( "Product_Category:::Tier_1" );
  prodCat.add( "Product_Category:::Tier_2" );
  prodCat.add( "Product_Category:::Tier_3" );
  prodCat.add( "Manufacturer" );
  prodCat.add( "Product_Name" );

  // Group Category
  List<String> searchGroup = new ArrayList<String>();
  autoFills.put( "SearchGroup", searchGroup );
  searchGroup.add( "Assigned_Support_Company" );
  searchGroup.add( "Assigned_Support_Organization" );
  searchGroup.add( "Assigned_Group" );
  searchGroup.add( "Assigned_Group_ID" );

  // If Group is found, what fields do we want to clear
  List<String> searchGroupClear = new ArrayList<String>();
  autoFillClears.put( "SearchGroupClear", searchGroupClear);
  searchGroupClear.add( "Assignee" );
  searchGroupClear.add( "Person_ID" );
  searchGroupClear.add( "Login_ID" );
  searchGroupClear.add( "Assigned_Group_Shift_Name" );

  // Assignee
  List<String> assignee = new ArrayList<String>();
  autoFills.put( "SearchAssignee", assignee );
  assignee.add( "Assigned_Group_Shift_Name" );
  assignee.add( "Assigned_Support_Company" );
  assignee.add( "Assigned_Support_Organization" );
  assignee.add( "Assigned_Group" );
  assignee.add( "Assigned_Group_ID" );
  assignee.add( "Assignee" );
  assignee.add( "Person_ID" );
  assignee.add( "Login_ID" );

  // Customer
  List<String> customer = new ArrayList<String>();
  autoFills.put( "SearchCustomer", customer );
  customer.add( "Company" );
  customer.add( "Customer" );
  customer.add( "First_Name" );
  customer.add( "Middle_Name" );
  customer.add( "Last_Name" );
  customer.add( "Phone_Number" );
  customer.add( "Organization" );
  customer.add( "Department" );
  customer.add( "Site" );
  customer.add( "Site_Group" );
  customer.add( "Site_ID" );
  customer.add( "Region" );
%>