<!DOCTYPE html PUBLIC "-//OMA//DTD XHTML Mobile 1.0//EN" "http://www.openmobilealliance.org/tech/DTD/xhtml-mobile10.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <title>AlarmPoint Mobile Gateway</title>
    <link rel="SHORTCUT ICON" href="/mg/images/logos/alarmpoint/logo.ico" type="image/x-icon" />

    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <meta http-equiv="Cache-Control" content="max-age=0" />
    <meta http-equiv="Pragma" content="no-cache" />
    <meta http-equiv="Expires" content="-1" />
    <!-- IE Mobile Meta Tag (optimized for 100% of the screen width) -->
    <meta name="MobileOptimized" content="100" />

    <style type="text/css" media="all" title="AlarmPoint Mobile Gateway">
      @import url("/mg/css/general.css");
      label.required {
        font-weight: bold;
        color: #990033;
      }
    </style>
  </head>

  <body>
    <form name="form" action="<%=response.encodeURL("action.jsp")%>" method="POST">
      <div id="header">
        <img src="/mg/images/misc/spacer.gif" height="35" width="100" id="logo" name="logo" alt="AlarmPoint Mobile Gateway" border="0" align="right" />
        <% String pageURL = action+"Incident.jsp"; %>
        <input type="hidden" name="pageURL" value="<%=pageURL%>"/>
        <%
        String tab = request.getParameter( "tab" );
        if ( tab != null )
        {
          %>
          <input type="hidden" name="tab" value="<%=tab%>"/>
          <%
        }
        tab = (tab == null ? "" : tab);
        IncidentScriptObject incident = (IncidentScriptObject)session.getAttribute("incident");
        Map<String, String> fieldTypes = new HashMap<String, String>();
        Map<String, String> fields = new LinkedHashMap<String, String>();
        Collection<String> requiredFields = new ArrayList<String>();
        %>
        <%@ include file="initialize.jsp"%>
        <%

        if ( incident != null )
        {
          if ( "create".equals( action ) )
          {
            %>
            <%@ include file="createFields.jsp"%>
            <%
          }
          else
          {
            %>
            <%@ include file="updateFields.jsp"%>
            <%
          }
        }
        %>
        <br><%
        String header = "<h1>New Incident</h1>";
        if ( !"create".equals( action ) )
        {
          header = incident.get( "Incident_Number", false ) + " - " + incident.get( "Summary", false );
          int MAX_HEADER = 30;
          if( header.length() > MAX_HEADER )
          {
            header = header.substring(0, MAX_HEADER-3)+"...";
          }
        }
        out.print(header);
        %>
      </div>
      <div id="content">
        <%
        if( request.getParameter("errorMessage") != null )
        {
          out.print( "<div class=\"msg-error\">" + request.getParameter( "errorMessage" ) + "</div>" );
        }
        else if ( request.getParameter("message") != null )
        {
          out.print( "<div class=\"msg-success\">" + request.getParameter("message") + "</div>" );
        }

        if ( incident != null )
        {
          if ( "work_info".equals( tab ) )
          {
            %><%@include file="workInfo.jsp"%><%
          }
          else if ( "financials".equals( tab ) )
          {
            %><%@include file="financials.jsp"%><%
          }
          else if ( "relationships".equals( tab ) )
          {
            %><%@include file="relationships.jsp"%><%
          }
          else
          {
          %>
          <table class="no-border">
          <%
            // Render all Fields defined in createFields or updateFields
            for ( String key : fields.keySet() )
            {
              String name = key;
              String label = fields.get( key );
              String labelAttr = "";
              String value = (String)incident.get( name, true);

              if ( "Hidden".equalsIgnoreCase( fieldTypes.get( key ) ) )
              {
                %><input type="hidden" name="<%=name%>" value="<%=value%>"/><%
                continue;
              }

              // Display information as a row with Label, if field type is not Table
              if ( fieldTypes.get( key ) != null &&
                   !fieldTypes.get( key ).startsWith( "Table" ) &&
                   !( "Notice".equals( fieldTypes.get( key) ) ) &&
                   !( "Date".equals( fieldTypes.get( key) ) ) &&
                   !( "DateInTable".equals( fieldTypes.get( key) ) ) )
              {
                if ( requiredFields.contains( name ) )
                {
                  labelAttr = " class=\"required\"";
                }
                %>
                <a name="<%=key%>"/>
                <tr>
                  <td class="align-right"><label<%=labelAttr%>><%=label%>:</label></td>
                  <td>
                <%
              }

              // Display a field according to field Type
              %><%@include file="incidentField.jsp"%><%

              // Display End row tag if field type is not Table
              if ( !fieldTypes.get( key ).startsWith("Table") &&
                   !( "Date".equals( fieldTypes.get( key) ) ) &&
                   !( "DateInTable".equals( fieldTypes.get( key) ) ) )
              {
              %>
                </td>
              </tr>
              <%
              }
            }
          %>
          <tr>
            <td class="no-border"></td>
            <%
            if ( tab.equals( "add_work_info" ) )
            {
            %>
            <td class="no-border"><input type="submit" name="action" value="Add Info" /></td>
            <%
            }
            else if ( tab.equals( "resolve" ) )
            {
            %>
            <td class="no-border"><input type="submit" name="action" value="Resolve" /></td>
            <%
            }
            else
            {
            %>
            <td class="no-border"><input type="submit" name="action" value="<%=actionLabel%>" /></td>
            <%
            }
            %>
          </tr>
        </table>
        <%
          }
        }
        %>
      </div>
    </form>

    <div id="footer">
      <div class="footer-links">
        <%
        if(session.getAttribute( "incidentHeaders" ) != null && ( (List)session.getAttribute( "incidentHeaders" ) ).size() > 1)
        {
          %>
          <a href="<%=response.encodeURL("listIncidents.jsp")%>">Prev List</a>&nbsp;-&nbsp;
          <%
        }
        %>
        <a href="<%=response.encodeURL("menu.jsp")%>">SD Menu</a>&nbsp;-&nbsp;
        <%
        if(mobileGatewaySession.getUser().getAccessibleServices().size() > 1)
        {
          %>
          <a href="<%=response.encodeURL("../listServices.jsp")%>">Services</a>&nbsp;-&nbsp;
          <%
        }
        %>
        <a href="<%=response.encodeURL("../logout.jsp")%>">Logout</a>
      </div>
    </div>
  </body>
</html>
