<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>

<%@ page import="java.util.*"%>
<%@ page import="org.apache.commons.lang.StringEscapeUtils"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.view.MobileGatewayUser"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.MobileGatewaySession"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceResponse"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceResponseCode"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceRequest"%>
<%@ page import="com.invoqsystems.apex.exceptions.AlarmPointDatabaseException"%>
<%@ page import="com.invoqsystems.apex.exceptions.AlarmPointNetworkException"%>
<%@ page import="com.invoqsystems.apex.web.exceptions.AlarmPointTimeOutException"%>
<%@ page import="com.invoqsystems.integration.remedy.scriptobjects.*"%>

<jsp:useBean class="com.alarmpoint.apex.mobilegateway.util.MobileGatewaySession"
             id="mobileGatewaySession"
             scope="session" />

<%@ include file="configuration.jsp"%>

<!DOCTYPE html PUBLIC "-//OMA//DTD XHTML Mobile 1.0//EN" "http://www.openmobilealliance.org/tech/DTD/xhtml-mobile10.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <title>AlarmPoint Mobile Gateway</title>
    <link rel="SHORTCUT ICON" href="/mg/images/logos/alarmpoint/logo.ico" type="image/x-icon" />

    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <meta http-equiv="Cache-Control" content="max-age=0" />
    <meta http-equiv="Pragma" content="no-cache" />
    <meta http-equiv="Expires" content="-1" />
    <!-- IE Mobile Meta Tag (optimized for 100% of the screen width) -->
    <meta name="MobileOptimized" content="100" />

    <style type="text/css" media="all" title="AlarmPoint Mobile Gateway">
      @import url("/mg/css/general.css");
      label.required {
        font-weight: bold;
        color: #990033;
      }
    </style>
  </head>

  <body>
  <a id="top" name="top"></a>

  <!---+
       + Header
       +--->
  <div id="header">
    <img src="/mg/images/misc/spacer.gif" height="35" width="100" id="logo" name="logo" alt="AlarmPoint Mobile Gateway" border="0" align="right" />
    <h1>BMC Remedy SD Menu</h1>
  </div>

  <!---+
       + Main content
       +--->
  <div id="content">
      <%
      MobileGatewayUser user = mobileGatewaySession.getUser();
      String sdUser = (String)request.getParameter("sdUser");
      String sdPass = (String)request.getParameter("sdPass");

      if ( sdUser == null )
      {
        sdUser = (String)session.getAttribute("sdUser");
      }
      if ( sdPass == null )
      {
        sdPass = (String)session.getAttribute("sdPass");
      }

      try
      {
        if ( sdUser == null )
        {
          sdUser = user.getCustomField( SD_USER_NAME_FIELD );
        }
        if ( sdPass == null )
        {
          sdPass = user.getCustomField( SD_PASSWORD_FIELD );
        }
      } catch( Exception e ) {
      }

      session.setAttribute( "sdUser", sdUser );
      session.setAttribute( "sdPass", sdPass );

      if ( VERIFY_SD_CREDS && sdUser != null )
      {
        ExternalServiceRequest esr = mobileGatewaySession.createExternalServiceRequest();
        ExternalServiceResponse resps;
        esr.setAction("validateCreds");
        %>
        <%@ include file="includes/sendRequest.jsp"%>
        <%
        String failedMessage = (String)resps.getResponse();
        if( failedMessage != null )
        {
          if ( failedMessage.equals("WS Fault: soapenv:Server.userException || ARERR [623] Authentication failed") )
          {
              failedMessage = "Authentication failure: Invalid user login or password";
              Integer retryAttempts = (Integer)session.getAttribute("LoginRetries");
              if ( retryAttempts == null )
              {
                  session.setAttribute( "LoginRetries", new Integer(1) );
              }
              else
              {
                  retryAttempts++;
                  if ( retryAttempts >= 3 )
                  {
                    %>
                    <jsp:forward page="<%=response.encodeURL("../logout.jsp")%>"/>
                    <%
                  }
                  session.setAttribute( "LoginRetries", retryAttempts );
              }
          }
          sdUser = null;
          session.removeAttribute("sdUser");
          session.removeAttribute("sdPass");
          out.print("<div class=\"msg-error\">"+failedMessage+"</div>");
        }
      }

      if(sdUser == null)
      //Display Service Desk Login Page
      {
      %>
      <form method="POST" action="<%=response.encodeURL("menu.jsp")%>">

        <table class="no-border">
          <tr>
            <td class="align-right"><label class="required">SD Login:</label></td>
            <td><input type="text" name="sdUser"/></td>
          </tr>
          <tr>
            <td class="align-right"><label class="required">SD Pass:</label></td>
            <td><input type="password" name="sdPass"/></td>
          </tr>
          <tr>
            <td></td>
            <td><input type="submit" name="Login" value="Login"/></td>
          </tr>
        </table>
      </form>
      <%
      }
      else
      {
        session.removeAttribute("LoginRetries");
      %>
      <ul>
        <li><a href="<%=response.encodeURL("loadIncident.jsp?newIncident")%>">Create New Incident.</a></li>
        <li><a href="<%=response.encodeURL("queryIncidents.jsp")%>">Query Incidents.</a></li>
        <p/>
        <%
        for(String option : MAIN_MENU_OPTIONS.keySet())
        {
          String count = "[0] ";
          String queryString = "?queryString=" + StringEscapeUtils.escapeXml( MAIN_MENU_OPTIONS.get( option ) );
          if ( MAIN_MENU_COUNTS )
          {
            ExternalServiceRequest esr = mobileGatewaySession.createExternalServiceRequest();
            ExternalServiceResponse resps;
            esr.setAction("getIncidentHeaders");
            esr.addToken("Qualification", MAIN_MENU_OPTIONS.get( option ) );
            %>
            <%@ include file="includes/sendRequest.jsp"%>
            <%
            if(resps.getResponse() instanceof String)
            {
              // Check if response inidicates nothing is found
              if(((String)resps.getResponse()).indexOf("ERROR (302)") > -1)
              {
                %>
				<li><%=count%><%=option%></li>
				<%
				break;
              }

              out.print("<div class=\"msg-error\">"+resps.getResponse()+"</div>");
            }
            else
            {
              List<GenericWSScriptObject> optionHeaders = (List<GenericWSScriptObject>)resps.getResponse();
              session.setAttribute( option, optionHeaders );
              count = "["+optionHeaders.size()+"] ";
              queryString = "?listAttribute="+StringEscapeUtils.escapeXml(option);
            }
          }
          String optionURL = response.encodeURL("listIncidents.jsp"+queryString);
          %>
          <li><%=count%><a href="<%=optionURL%>"><%=option%></a></li>
          <%
        }
        %>
        <li>&nbsp;</li>
      </ul>
      <%
      }
      %>
    </div>

    <div id="footer">
      <div class="footer-links">
        <%@ include file="includes/standardFooterLinks.jsp"%>
      </div>
    </div>
  </body>
</html>
