<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page import="java.util.*"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.view.MobileGatewayUser"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.MobileGatewaySession"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceResponse"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceResponseCode"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceRequest"%>
<%@ page import="com.invoqsystems.apex.exceptions.AlarmPointDatabaseException"%>
<%@ page import="com.invoqsystems.apex.exceptions.AlarmPointNetworkException"%>
<%@ page import="com.invoqsystems.apex.web.exceptions.AlarmPointTimeOutException"%>
<%@ page import="com.invoqsystems.integration.remedy.scriptobjects.*"%>

<jsp:useBean class="com.alarmpoint.apex.mobilegateway.util.MobileGatewaySession" id="mobileGatewaySession" scope="session" />

<%
if ( request.getParameter("Help") != null )
{
  %>
  <jsp:forward page="<%=response.encodeURL("queryIncidentHelp.jsp")%>"/>
  <%
}
%>

<%@ include file="configuration.jsp"%>

<html>
  <head>
    <title>AlarmPoint Mobile Gateway</title>
    <link rel="SHORTCUT ICON" href="/mg/images/logos/alarmpoint/logo.ico" type="image/x-icon" />

    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <meta http-equiv="Cache-Control" content="max-age=0" />
    <meta http-equiv="Pragma" content="no-cache" />
    <meta http-equiv="Expires" content="-1" />
    <!-- IE Mobile Meta Tag (optimized for 100% of the screen width) -->
    <meta name="MobileOptimized" content="100" />

    <style type="text/css" media="all" title="AlarmPoint Mobile Gateway">
      @import url("/mg/css/general.css");

      table td.pri-Critical {
        background: #990033;
        font-weight: bold;
        color: #FFFFFF;
        white-space: nowrap;
      }

      table td.pri-High {
        background: #0000CC;
        font-weight: bold;
        color: #FFFFFF;
        white-space: nowrap;
      }

      table td.pri-Medium {
        background: #FFFFEE;
        white-space: nowrap;
      }

      table td.pri-Low {
        background: #FFFFFF;
        white-space: nowrap;
      }
    </style>
  </head>

  <body>
    <div id="header">
      <img src="/mg/images/misc/spacer.gif" height="35" width="100" id="logo" name="logo" alt="AlarmPoint Mobile Gateway" border="0" align="right" />
      <%
      // Pagination
      String pageURL = "queryIncidents.jsp";
      String queryLink = response.encodeURL("queryIncidents.jsp");
      if ( request.getParameter("page") != null && session.getAttribute("incidentHeaders") != null )
      {
        List<GenericWSScriptObject> incidentHeaders = (List)session.getAttribute("incidentHeaders");
        if ( incidentHeaders == null )
          incidentHeaders = new ArrayList<GenericWSScriptObject>();
        %>
        <H1>Query Incidents [<%=incidentHeaders.size()%>]</H1>
        </div>
        <div id="content">
        <%@ include file="includes/tableOfIncidents.jsp"%>
        <br>
        <a href="<%=response.encodeURL("queryIncidents.jsp")%>">New Query</a>
        <%
      }
      // New Query
      else if(request.getParameter("field_0") == null && request.getParameter("field_1") == null && request.getParameter("field_2") == null)
      {
      %>
      <H1>Query Incidents</H1>
    </div>
    <div id="content">
      <form name="fields" method="POST" action="<%=queryLink %>">
        <table>
          <tr>
            <th>Field</th>
            <th>Op</th>
            <th>Value</th>
          </tr>
        <%
        for ( int i=0; i < NUM_SEARCH_FIELDS; i++ )
        {
        %>
          <tr>
            <td>
              <select name="field_<%=i%>">
              <%
              if ( i > 0 )
              {
              %>
                <option value=""></option>
              <%
              }
              for(String field : searchFieldsDisplay.keySet())
              {
              %>
                <option value="<%=field %>"><%=searchFieldsDisplay.get(field)%></option>
              <%
              }
              %>
              </select>
            </td>
            <td>
              <select name="field_<%=i%>_operator">
                <option value="like">like</option>
                <option value="eq">eq</option>
                <option value="not">not</option>
                <option value="lt">lt</option>
                <option value="lte">lte</option>
                <option value="gt">gt</option>
                <option value="gte">gte</option>
              </select>
            </td>
            <td>
              <%
              if ( i == 0 )
              {
                %>
                <input type="text" name="field_<%=i%>_value" value='"%"' size="10" />
                <%
              } else {
                %>
                <input type="text" name="field_<%=i%>_value" size="10" />
                <%
              }
              %>
            </td>
          </tr>
        <%
        }
        %>
        </table>
        <input name="submit" type="submit" />
        <input name="Help" value="Help" type="submit" />
      </form>
      <%
      }
      // Return result
      else
      {
        QueryObject query = new QueryObject();

        List<String> fields =
            Arrays.asList( new String[]{ "field_0", "field_1", "field_2" } );

        for ( String field : fields )
        {
          if ( request.getParameter( field ) != null &&
               request.getParameter( field ).length() > 0 )
          {
            QueryField qField = new QueryField();
            qField.setFieldMap( searchFieldsRemedyName );
            qField.setFieldTypes( searchFieldsType );
            qField.setField( request.getParameter( field ) );

            String operator = request.getParameter( field + "_operator" );

            qField.setOperator( new QueryLogic( operator ) );
            qField.setValue( request.getParameter( field + "_value" ) );
            query.getFields().add( qField );
          }
        }

        String message = "";
        ExternalServiceRequest esr = mobileGatewaySession.createExternalServiceRequest();
        ExternalServiceResponse resps;
        esr.setAction("getIncidentHeaders");
        esr.addToken( "Qualification", query.getQualification() );
        %>
        <%@ include file="includes/sendRequest.jsp"%>
        <%
        List<GenericWSScriptObject> incidentHeaders = new ArrayList<GenericWSScriptObject>();
        if( resps.getResponse() instanceof String )
        {
          String responseStr = (String)resps.getResponse();
          responseStr = responseStr.replaceAll("\n"," ");
          responseStr = responseStr.replaceAll( "JavaException: java.lang.Exception: WS Fault: soapenv:Server.userException [|]+[ ]+" +
                  "MessageType: [0-9]+[ ]+"+
                  "MessageNum: [0-9]+[ ]+"+
                  "MessageText: Data types are not appropriate for relational operation[ ]+" +
                  "AppendedText:[ ]+", "Field cannot use relational operator");

          message = "<div class=\"msg-error\">"+responseStr+"</div>";
        }
        else if ( resps.getResponse() != null )
        {
            incidentHeaders = (List<GenericWSScriptObject>)resps.getResponse();
        }
        session.setAttribute( "incidentHeaders", incidentHeaders );
        %>
        <H1>Query Incidents [<%=incidentHeaders.size()%>]</H1>
        </div>
        <div id="content">
        <%=message%>
        <%@ include file="includes/tableOfIncidents.jsp"%>
        <br>
        <a href="<%=response.encodeURL("queryIncidents.jsp")%>">New Query</a>
        <%
      }
      %>
    </div>
    <div id="footer">
      <div class="footer-links">
        <a href="<%=response.encodeURL("menu.jsp")%>">SD Menu</a>&nbsp;-&nbsp;
        <%
        if(mobileGatewaySession.getUser().getAccessibleServices().size() > 1)
        {
        %> <a href="<%=response.encodeURL("../listServices.jsp")%>">Services</a>&nbsp;-&nbsp; <%
        }
        %>
        <a href="<%=response.encodeURL("../logout.jsp")%>">Logout</a></div>
    </div>
  </body>
</html>