<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page import="java.util.*"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.view.MobileGatewayUser"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.MobileGatewaySession"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceResponse"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceResponseCode"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceRequest"%>
<%@ page import="com.invoqsystems.apex.exceptions.AlarmPointDatabaseException"%>
<%@ page import="com.invoqsystems.apex.exceptions.AlarmPointNetworkException"%>
<%@ page import="com.invoqsystems.apex.web.exceptions.AlarmPointTimeOutException"%>
<%@ page import="com.invoqsystems.integration.remedy.scriptobjects.*"%>

<jsp:useBean class="com.alarmpoint.apex.mobilegateway.util.MobileGatewaySession" id="mobileGatewaySession" scope="session" />
<%@ include file="configuration.jsp"%>
<%
String searchTitle = "Search Method";
%>

<!DOCTYPE html PUBLIC "-//OMA//DTD XHTML Mobile 1.0//EN" "http://www.openmobilealliance.org/tech/DTD/xhtml-mobile10.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <title>AlarmPoint Mobile Gateway</title>
    <link rel="SHORTCUT ICON" href="/mg/images/logos/alarmpoint/logo.ico" type="image/x-icon" />

    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <meta http-equiv="Cache-Control" content="max-age=0" />
    <meta http-equiv="Pragma" content="no-cache" />
    <meta http-equiv="Expires" content="-1" />
    <!-- IE Mobile Meta Tag (optimized for 100% of the screen width) -->
    <meta name="MobileOptimized" content="100" />

    <style type="text/css" media="all" title="AlarmPoint Mobile Gateway">
      @import url("/mg/css/general.css");
      label.required {
        font-weight: bold;
        color: #990033;
      }
    </style>
  </head>

  <body>
    <%
    String field = (String)request.getParameter("field");
    String url = (String)request.getParameter("url");
    String tab = (String)request.getParameter("tab");
    %>
    <form name="form" action="<%=response.encodeURL("searchResolutionMethod.jsp?field="+field+"&url="+url+"&tab="+tab)%>" method="POST">
      <div id="header">
        <img src="/mg/images/misc/spacer.gif" height="35" width="100" id="logo" name="logo" alt="AlarmPoint Mobile Gateway" border="0" align="right" />
        <h1><%=searchTitle%></h1>
      </div>
      <div id="content">

        <%
        if( request.getParameter("method") != null && url != null && field != null )
        {
          String method = (String)request.getParameter("method");
          if( session.getAttribute("incident") != null )
          {
            IncidentScriptObject incident = (IncidentScriptObject)session.getAttribute("incident");
            incident.addUpdate( "Resolution:::Resolution_Method", method );
          }
          %>
          <jsp:forward page="<%=response.encodeURL(url+"?tab="+tab)%>"/>
          <%
        }
        else if(request.getParameter("searchValue") != null && !"".equals(request.getParameter("searchValue")))
        {
          QueryObject query = new QueryObject();
          QueryField queryField = new QueryField();
          queryField.setField( "Menu Label 1" );
          queryField.setOperator( new QueryLogic( (String)request.getParameter("searchOperator") ) );
          queryField.setValue((String)request.getParameter("searchValue"));
          query.getFields().add( queryField );

          // Original Menu Qualification CFG:MNI:ResolutionMethod-Q
          String qualification = "( 'Menu Type' =  \"Resolution Method\" ) AND ( 'Status' = \"Enabled\")";
          qualification = "("+query.getQualification()+") AND (" + qualification +")";

          ExternalServiceRequest esr = mobileGatewaySession.createExternalServiceRequest();
          ExternalServiceResponse resps;
          esr.setAction("queryGenericList");
          esr.addToken( "service", "ResolutionMethod" );
          esr.addToken( "max_limit", MAX_SEARCH_RESULTS1 );
          esr.addToken( "Qualification", qualification );
          %>
          <%@ include file="includes/sendRequest.jsp"%>
          <%
          List<GenericWSScriptObject> methods = new ArrayList<GenericWSScriptObject>();
          if( resps.getResponse() instanceof String )
          {
            %>
            <%@ include file="includes/searchErrorMsg.jsp"%>
            <%
          }
          else if ( resps.getResponse() != null )
          {
            methods = (List<GenericWSScriptObject>)resps.getResponse();

            if( methods.size() == 0 )
            {
              out.print("<div class=\"msg-warning\">No Results Found</div>");
            }
            else
            {
              if ( methods.size() >= MAX_SEARCH_RESULTS1 )
              {
                out.print("<div class=\"msg-warning\">The query matched more than the maximum number of entries specified for retrieval. Please refine search criteria if necessary.</div>");
              }
              %>
              <table>
                <tr>
                  <th>Method</th>
                </tr>
                <%
                for( GenericWSScriptObject method : methods )
                {
                  %>
                  <tr>
                    <td><a href="<%=response.encodeURL("searchResolutionMethod.jsp?field="+
                            field+
                            "&url="+url+
                            "&tab="+tab+
                            "&method=" + method.get("Menu_Label_1"))%>"><%=method.get("Menu_Label_1")%></a></td>
                  </tr>
                  <%
                }
                %>
              </table>
            <%
            }
          }
          %>
          <a href="<%=response.encodeURL("searchResolutionMethod.jsp?field="+field+"&url="+url+"&tab="+tab)%>">Search Again</a>
          <%
        }
        else
        {
          QueryLogic operatorTemplate = new QueryLogic();
          %>
          <table>
            <tr>
              <th>Field</th>
              <th>Op</th>
              <th>Value</th>
            </tr>
            <tr>
              <td>Method</td>
              <td>
                <select name="searchOperator">
                  <%
                  for( String operator : operatorTemplate.getOperatorMap().keySet() )
                  {
                  %>
                  <option value="<%=operator%>"><%=operator%></option>
                  <%
                  }
                  %>
                </select>
              </td>
              <td>
                <input type="text" name="searchValue" size="10" value='"%"'/>
              </td>
            </tr>
          </table>
          <input type="submit" name="search" value="Search"/>
          <%
        }
        %>
      </div>
    </form>
    <a href="<%=response.encodeURL(url+"?tab="+tab)%>">Back to Details</a>

    <div id="footer">
      <div class="footer-links">
        <a href="<%=response.encodeURL("menu.jsp")%>">SD Menu</a>&nbsp;-&nbsp;
        <%
        if(mobileGatewaySession.getUser().getAccessibleServices().size() > 1)
        {
          %>
          <a href="<%=response.encodeURL("../listServices.jsp")%>">Services</a>&nbsp;-&nbsp;
          <%
        }
        %>
        <a href="<%=response.encodeURL("../logout.jsp")%>">Logout</a>
      </div>
    </div>
  </body>
</html>