<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page import="java.util.*"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.view.MobileGatewayUser"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.MobileGatewaySession"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceResponse"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceResponseCode"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceRequest"%>
<%@ page import="com.invoqsystems.apex.exceptions.AlarmPointDatabaseException"%>
<%@ page import="com.invoqsystems.apex.exceptions.AlarmPointNetworkException"%>
<%@ page import="com.invoqsystems.apex.web.exceptions.AlarmPointTimeOutException"%>
<%@ page import="com.invoqsystems.integration.remedy.scriptobjects.*"%>

<jsp:useBean class="com.alarmpoint.apex.mobilegateway.util.MobileGatewaySession" id="mobileGatewaySession" scope="session" />

<%@ include file="configuration.jsp"%>

<!DOCTYPE html PUBLIC "-//OMA//DTD XHTML Mobile 1.0//EN" "http://www.openmobilealliance.org/tech/DTD/xhtml-mobile10.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <title>AlarmPoint Mobile Gateway</title>
    <link rel="SHORTCUT ICON" href="/mg/images/logos/alarmpoint/logo.ico" type="image/x-icon" />

    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <meta http-equiv="Cache-Control" content="max-age=0" />
    <meta http-equiv="Pragma" content="no-cache" />
    <meta http-equiv="Expires" content="-1" />
    <!-- IE Mobile Meta Tag (optimized for 100% of the screen width) -->
    <meta name="MobileOptimized" content="100" />

    <style type="text/css" media="all" title="AlarmPoint Mobile Gateway">
      @import url("/mg/css/general.css");
      label.required {
        font-weight: bold;
        color: #990033;
      }
    </style>
  </head>

  <body>
    <a id="top" name="top"></a>

    <div id="header">
      <img src="/mg/images/misc/spacer.gif" height="35" width="100" id="logo" name="logo" alt="AlarmPoint Mobile Gateway" border="0" align="right" />
      <h1>BMC Remedy SD Menu</h1>
    </div>

    <div id="content">
      <%
      MobileGatewayUser user = mobileGatewaySession.getUser();
      String sdUser = (String)request.getParameter("sdUser");
      String sdPass = (String)request.getParameter("sdPass");

      if(sdUser == null)
        sdUser = (String)session.getAttribute("sdUser");
      if(sdPass == null)
        sdPass = (String)session.getAttribute("sdPass");

      try
      {
        if ( sdUser == null )
        {
          sdUser = user.getCustomField( SD_USER_NAME_FIELD );
        }
        if ( sdPass == null )
        {
          sdPass = user.getCustomField( SD_PASSWORD_FIELD );
        }
      }catch(Exception e){
      }

      session.setAttribute("sdUser", sdUser);
      if(sdPass == null)
        sdPass = "";
      session.setAttribute("sdPass", sdPass);

      if(VERIFY_SD_CREDS && sdUser != null)
      {
        ExternalServiceRequest esr = mobileGatewaySession.createExternalServiceRequest();
        ExternalServiceResponse resps;
        esr.setAction("validateCreds");
        %>
        <%@ include file="includes/sendRequest.jsp"%>
        <%
        String failedMessage = (String)resps.getResponse();
        if(failedMessage != null)
        {
          sdUser = null;
          session.removeAttribute("sdUser");
          session.removeAttribute("sdPass");
          out.print("<div class=\"msg-error\">"+failedMessage+"</div>");
        }
      }

      if(sdUser == null)
      //Display SD Login Page
      {
      %>
      <form method="POST" action="<%=response.encodeURL("urlAlias.jsp?identifier="+request.getParameter("identifier"))%>">

        <table class="no-border">
          <tr>
            <td class="align-right"><label class="required">SD Login:</label></td>
            <td><input type="text" name="sdUser"/></td>
          </tr>
          <tr>
            <td class="align-right"><label class="required">SD Pass:</label></td>
            <td><input type="password" name="sdPass"/></td>
          </tr>
          <tr>
            <td></td>
            <td><input type="submit" name="Login" value="Login"/></td>
          </tr>
        </table>
      </form>
      <%
      }
      else
      {
        if(request.getParameter("newIncident") == null)
        {
          // Update Incident
          ExternalServiceRequest esr = mobileGatewaySession.createExternalServiceRequest();
          ExternalServiceResponse resps;
          esr.setAction("getIncidentDetail");
          esr.addToken("IncidentNumber", request.getParameter("IncidentNumber"));
          %>
          <%@ include file="includes/sendRequest.jsp"%>
          <%
          if(resps.getResponse() instanceof String)
          {
            session.setAttribute("incident", null);
            %>
            <jsp:forward page="<%=response.encodeURL("updateIncident.jsp?errorMessage="+(String)resps.getResponse())%>"/>
            <%
          }
          else
          {
            IncidentScriptObject incident = (IncidentScriptObject)resps.getResponse();
            %>
            <%@ include file="includes/updateWSFields.jsp"%>
            <%
            if(incident != null){
              for(String key: incident.getWSFields().keySet()){
                if(request.getParameter(key) != null)
                  incident.addUpdate(incident.getWSFields().get(key), (String)request.getParameter(key));
              }
            }
            session.setAttribute("incident", incident);
            %>
            <jsp:forward page="<%=response.encodeURL("updateIncident.jsp")%>"/>
            <%
          }
        }
        else
        {
          // Create Incident
          IncidentScriptObject incident = new IncidentCreation();
          %>
          <%@ include file="includes/createWSFields.jsp"%>
          <%
          if(incident != null){
            for(String key: incident.getWSFields().keySet()){
              if(request.getParameter(key) != null)
                incident.addUpdate(incident.getWSFields().get(key), (String)request.getParameter(key));
            }
          }
          session.setAttribute("incident", incident);
          %>
          <jsp:forward page="<%=response.encodeURL("createIncident.jsp")%>"/>
          <%
        }
      }
      %>

    </div>

    <div id="footer">
      <div class="footer-links">
        <%
        if(mobileGatewaySession.getUser().getAccessibleServices().size() > 1)
        {
        %>
        <a href="<%=response.encodeURL("../listServices.jsp")%>">Services</a>&nbsp;-&nbsp; <%
        }
        %>
        <a href="<%=response.encodeURL("../logout.jsp")%>">Logout</a>
      </div>
    </div>
  </body>
</html>